"""
_MotT0Page_
Generic class representing a page of the MotT0 monitoring system.
 
""" 
from WMCore.WebTools.Page import TemplatedPage

from Table import *
from TableContents import *
from Statistics import *
from MotT0 import MotT0Page



class MotT0Run(MotT0Page):
    
    title="MotT0 Run %s page"
    error=False
     
    def getTemplate(self):
       try:
         self.runid=self.params['run_id']
         run=int(self.runid)
       except:
         self.error=True
         return
       self.title=self.title%(self.runid)
       if self.error==True:
           eParams={
            "title": "Error",
            "time" : ctime(),
            "tmplPath": self.templatedir,
            "msg": "Wrong  run_id input.  Please check URL and reload. "
              }
           return self.motT0Template.templatepage('error', **eParams )
       
       params={
            "page": "run",
            "title": self.title,
            "runid": self.runid,
            "time" : ctime(),
            "tmplPath": self.templatedir,
            "topLinks":""" <a href="statplots?run_id=%d&autotime=1"> <img border="0" src="imgs/plot.png" alt="run-plots" title="statistical plots for run: %d" width="25"> </a>"""%(run,run)
              }
       return self.motT0Template.templatepage('run', **params )
