"""
_MotT0StatPlots Page_

""" 

from time import *
from SeriesLib import *
from datetime import datetime
from PlotLib import *
from TableContents import content
import Utils,PlotLib,SeriesLib


class plotContent(content):
  message=""
  fileExists=False
  URL=""
  prefix=" "
  optionLink="""<a id="%sLabel" href="javascript:showAndHide('%sInfo','%sLabel','Show Options','Hide Options')">Show Options</a>""" 
  
  def checkParams(self):
    """ This method is used to check and set the basic plot parameters according with the URL options"""
    pass
  
  def getFileName(self):
    """ This method generates for each plot its filename. filename MUST be unique: to do this use the plot parameters!"""
    pass
  
  
  def getOptionsPanel(self):
    """This method generates :Summary + Plot Updating Form HTML code"""
    pass
  
  ##########################all parameter checks 
  def checkTierP(self,kwargs): 
      try:
          self.tier=kwargs['tier'].upper()
      except Exception, e:
          self.message+="<BR/>Wrong Tier value"
          self.tier=""
          
  def checkAutoTimeP(self,kwargs):
      self.autotime=False 
      try:
          autotime=int(kwargs['autotime'])
          if (autotime==1):
            self.autotime=True
      except Exception, e:
          pass
          
  def checkLoadSiblingsP(self,kwargs):
      self.loadSiblings=False
      try:
          self.loadSiblings=int(kwargs['loadsiblings'])==1
      except Exception, e:
          pass
          
  def checkHoursP(self,MIN,MAX,kwargs):
      try:
         self.hours=int(kwargs['hours'])
      except:
         self.hours=MAX
         self.message="<BR/>Time interval is back to DEFAULT value. Accepted range: %d - %dh."%(MIN,MAX)
         
      if self.hours>MAX or self.hours<MIN: 
        #check for in range hours
        self.hours=max(MIN,min(MAX, self.hours))
        self.message+="<BR/>Time interval is back to DEFAULT value. Accepted range: %d - %dh."%(MIN,MAX)


  def checkRunP(self,kwargs): 
      try:
         tmp=kwargs['run_id']
         if len(str(tmp))>0:
           self.run=int(tmp)
      except Exception,e:
        self.message+="<BR/>Run value not found or not valid. Showing whole system's plots."
      
  def checkStepP(self,MIN,MAX,default,kwargs):
      try:
         self.step=int(kwargs['step'])
      except:
         self.step=default
         self.message+="<BR/>Step length value is back to DEFAULT value. Accepted range: %d - %d minutes."%(MIN,MAX)
         
      if self.step>MAX or self.step<MIN: 
        #check for in range hours
        self.step=max(MIN,min(MAX, self.step))
        self.message+="<BR/>Time interval is back to DEFAULT value. Accepted range: %d - %d minutes."%(MIN,MAX)
          
  def getSummary(self):
    """
    This method must be called after the query is executed because if the autotime option is active the start and end time are not known before processing the data from DAS
    """
    summary="" 
    try:
     sd=datetime.fromtimestamp(self.startTime)
     ed=datetime.fromtimestamp(self.endTime)
     if self.step>0 or "Rate" in self.plotName: #Rate plot must use an interval
      interval="""in intervals of <B>%d</B> minute(s)"""%(max(self.step,1))
     else:interval="""(all events)"""
     summary="""Showing : <B>%d</B> hours %s <BR/> from <B>%d:00</B> of <B>%s %d/%d/%d</B> <BR/> to:&nbsp;&nbsp;&nbsp;&nbsp;  <B>%d:00</B> of <B>%s %d/%d/%d</B> """%(self.hours,interval,sd.hour,sd.strftime("%A"),sd.day,sd.month,sd.year,ed.hour,ed.strftime("%A"),ed.day,ed.month,ed.year)
     if self.autotime:
           summary+="<BR/>Auto-selection of the time parameters: <span style=\"color:green\"><B> ON</B></span>"
     else: summary+="<BR/>Auto-selection of the time parameters: <span style=\"color:red\"><B> OFF </B></span>"
    except Exception, e:
      print e
      #"Plot information not available"
      summary=""
    return summary
        
      

  def checkDateP(self,MIN,MAX,kwargs):
      ############################# date
      #MAX= mktime(localtime())
      #MIN =mktime(datetime(2010, 1, 1, 0, 0, 0).timetuple())
      try:
          fromH=int(kwargs['sh'])
          fromD=int(kwargs['sd'])
          fromM=int(kwargs['sm'])
          fromY=int(kwargs['sy'])
          d=datetime(fromY, fromM, fromD, fromH)
          #print "Y="+str(fromY)+" M="+str(fromM)+" D="+str(fromD)+" H="+str(fromH)
          self.endTime=mktime(d.timetuple())
          if (self.endTime>MAX) or (self.endTime<MIN):
             self.message+="<BR/> Date out of range"
             raise Exception()
      except Exception:
           self.message+="<BR/> Date input error: value is back to DEFAULT value."
           self.endTime=MAX
###########################################################################################################################################################################3
class statPlotContent(plotContent):
  """ Statistical plots are Bar Plots
   POSSIBLE INPUTS: step, hours, starting date (hour/day/month/year) and run_id + autotime option (shows the most important area of the plot automatically)
   """
  MAX_HOURS=48
  MIN_STEP=5
  MAX_STEP=60
          
          
  def checkParams(self):
    self.name=self.prefix+'Stat' #name
    self.plotName=self.prefix+'BarPlot' # name of the plot object
    self.stepRange=range(self.MIN_STEP,5)+range(5,self.MAX_STEP+5,5)
    self.hourRange=[1,2,3,4,5]+range(6,self.MAX_HOURS+1,6)
    #### create options field
    self.run=None
    self.autotime=False
    self.hours=None
    self.startTime=None
    self.endTime=None
    self.step=None
    
    ########### check for actual parameters
    try:
      self.checkRunP(self.params)
      self.checkAutoTimeP(self.params)
      
      if not(self.autotime):
        self.checkHoursP(1,self.MAX_HOURS,self.params)
        
        defaultStep=int((self.hours*2/5)*5)
        self.step=defaultStep
        if 'step' in self.params.keys(): 
           self.checkStepP(self.MIN_STEP,self.MAX_STEP,defaultStep,self.params)
        self.step=max(self.MIN_STEP,min(self.MAX_STEP,self.step))
        
        # I can ignore the starting date, BUT if there are data I have to check them 
        if ('sh' in self.params.keys()) or ('sd' in self.params.keys()) or  ('sy' in self.params.keys()) or ('sm' in self.params.keys()) or ('hours' in self.params.keys()):  
           self.checkDateP(mktime(datetime(2010, 1, 1, 0, 0, 0).timetuple()),mktime(localtime()),self.params)
        else: 
          self.endTime=mktime(localtime())
        self.queryTime=self.hours*60*60
        #round at +/- 5 minutes (to enable caching)
        self.endTime=math.floor(self.endTime/300)*300
        self.startTime=self.endTime-self.queryTime
      else:
         # autotime options works for run specific plots: if it is active for the general plots I simply set up the default values for time interval and step
         if self.run==None: 
           self.hours=self.MAX_HOURS
           self.step=max(self.MIN_STEP,min(self.MAX_STEP,int((self.hours*2/5)*5)))
           self.endTime=mktime(localtime())
           self.queryTime=self.hours*60*60
           #round at +/- 5 minutes (to enable caching)
           self.endTime=math.floor(self.endTime/300)*300
           self.startTime=self.endTime-self.queryTime
           self.autotime=False
    except Exception, e:
       self.message="<BR />Parameter check FAILED <BR/>"+self.message
       print "Exception in parameter check:"+e
              
  def updateLinks(self):
      if len(self.URL)>0:
       runString=str(self.run)
       if self.run==None or self.run<1: 
           runString="" 
       if type (self.URL)==StringType:
           if self.startTime!=None and self.endTime!=None:
            self.URL=self.URL%(str(self.startTime),str(self.endTime),str(runString))
           else:
            self.URL=self.URL%("","",str(runString))
       if type (self.URL)==ListType:
           newUrl=[]
           for url in self.URL:
             if self.startTime!=None and self.endTime!=None:
              newUrl.append(url%(str(self.startTime),str(self.endTime),str(runString)))
             else:
              newUrl.append(url%("","",str(runString)))
           self.URL=newUrl
               
  def getFileName(self):
      options=""
      if self.run!=None and self.run>0:
        options+="-%d"%(self.run)
      if not(self.autotime) and len(str(self.startTime))>0:
       options+="-"+str(self.startTime)+'-'+str(self.endTime)
      if not(self.autotime) and len(str(self.step))>0:
        options+="-"+str(self.step)
      if self.autotime:
         options+="-"+str(mktime(localtime())) # run-specific plots with auto-time are not used for multiple requests! 
      fileName="jsonData-"+str(self.name)+options+".json"
      return fileName
       
       
  def makePlotOn(self,data,plotfairyUrl):
     self.plotfairyUrl=plotfairyUrl
     if self.autotime==True:
        ## if there is not data I can't have min and max: anyway the plot will fail later with this exception
        if data==None or len(data)==0: 
           raise EmptyPlotException()
        self.startTime=data[min(range(0,len(data)),key=lambda w: data[w]['starttime'])]['starttime']
        self.endTime=  data[max(range(0,len(data)),key=lambda w: data[w]['endtime'])]['endtime'] ## get max value in endtime
        self.hours=int((self.endTime-self.startTime)/3600)
        #print "AUTOTIME="+str((self.content.endTime-self.content.startTime)/3600)
        self.step=int((self.endTime-self.startTime)/(60*50))
        if self.step<1: self.step=1
        
     serie=intervalSerie(self.name,int(self.startTime),int(self.endTime),self.step*60) #minutes to seconds
     for line in data:
            serie.addInfo(line)
     plotClass=getattr(PlotLib,self.plotName)
     plot=plotClass(self.plotfairyUrl,serie)
     return plot
      
  def  getOptionsPanel(self):
    ##print the errors in the paramenters with the result
    prefix=self.getSummary()
    if len(prefix)>0: 
      prefix="<B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Plot information:</B> <BR/>"+prefix
    if len(str(self.message))>0:
            self.message="<B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Parameters log:</B>"+self.message
         
    self.optionLink=self.optionLink%(self.name,self.name,self.name) 
    form =""
    try:
      #if self.endTime==None: 
        ## cached plot
        #self.endTime=mktime(localtime())
        #self.step=5 
      dtime=datetime.fromtimestamp(self.endTime)
      form =PlotLib.dateForm(self.name,dtime,self.hours,self.hourRange,self.step,self.stepRange, self.run)
    except Exception, e:
       print e 
    #if len(prefix)>0 or len(form)>0:
    if True:
      res=self.optionLink+"""<BR/><div id=%s style="display: none;" align="left">"""%(self.name+"Info")
      if len(prefix)>0:
        res+=prefix+"<BR/>"
      if len(self.message)>0:
        res+=self.message+"<BR/>"
      if len(form)>0:
       res+=form
      res+="</div>"
    return res 
              
        
#######################################################################################################################################
class expressStat(statPlotContent):
  prefix='express'
  URL='expresslifetimes?stime=%s&etime=%s&run=%s'
  
class expressmergeStat(statPlotContent):
  prefix='expressmerge'
  URL='expressmergelifetimes?stime=%s&etime=%s&run=%s'
  
  
class repackStat(statPlotContent):
  prefix='repack'
  URL='repacklifetimes?stime=%s&etime=%s&run=%s'
  
  
class repackmergeStat(statPlotContent):
  prefix='repackmerge'
  URL='repackmergelifetimes?stime=%s&etime=%s&run=%s'
  
  
class recoStat(statPlotContent):
  prefix='reco'
  URL='recolifetimes?stime=%s&etime=%s&run=%s'
  
  
class recomergeStat(statPlotContent):
  prefix='recomerge'
  URL='recomergelifetimes?stime=%s&etime=%s&run=%s'
  
  
class alcaStat(statPlotContent):
  prefix='alca'
  URL='alcalifetimes?stime=%s&etime=%s&run=%s'
  
  
class alcamergeStat(statPlotContent):
  prefix='alcamerge'
  URL='alcamergelifetimes?stime=%s&etime=%s&run=%s'
  
class allJobsStat(statPlotContent):
  prefix='allJobs'
  MAX_HOURS=200
  MIN_STEP=1
  MAX_STEP=60
  URL=['expresslifetimes?stime=%s&etime=%s&run=%s','expressmergelifetimes?stime=%s&etime=%s&run=%s',
       'repacklifetimes?stime=%s&etime=%s&run=%s','repackmergelifetimes?stime=%s&etime=%s&run=%s',
       'recolifetimes?stime=%s&etime=%s&run=%s','recomergelifetimes?stime=%s&etime=%s&run=%s',
        'alcalifetimes?stime=%s&etime=%s&run=%s','alcamergelifetimes?stime=%s&etime=%s&run=%s']
################################################################################################################################################
class tierPlotContent(plotContent):
  """
   tier+ streamers Plot content
   This class has few more options/methods in order to handle the "layer": the group of 3 plots with the same legend
  """
  MAX_HOURS=5
  URL="lastfilessummary?stime=%s&etime=%s&tier=%s"
  name=""
  MIN_STEP=0
  MAX_STEP=20
  layerCont=['events','eventsizes','datarate']
  suffix=""
  
  def filterFunction(self,x):
    return True
  
  def checkParams(self):
    self.name=self.__class__.__name__
    self.hourRange=[1,2,3,4,5]+range(6,self.MAX_HOURS+1,6)
    self.stepRange=range(self.MIN_STEP,self.MAX_STEP)+[10,15,20]
       #### create options field
    self.loadSiblings=False
    self.loadSiblingsScript=""
    self.hours=None
    self.autotime=None
    self.startTime=None
    self.endTime=None
    self.tier=""
    self.step=1
    
    try:
      self.checkTierP(self.params)
      self.checkAutoTimeP(self.params)
      self.checkLoadSiblingsP(self.params)
      
      if not(self.autotime):
        self.checkHoursP(1,self.MAX_HOURS,self.params)
        # I can ignore the starting date, BUT if there are data I have to check them 
        if ('sh' in self.params.keys()) or ('sd' in self.params.keys()) or  ('sy' in self.params.keys()) or ('sm' in self.params.keys()):  
          self.checkDateP(mktime(datetime(2010, 1, 1, 0, 0, 0).timetuple()),mktime(localtime()),self.params)
        else: 
         self.endTime=mktime(localtime())
         
        defaultStep=1
        self.step=defaultStep
        if 'step' in self.params.keys(): 
           self.checkStepP(self.MIN_STEP,self.MAX_STEP,defaultStep,self.params)
        self.step=max(self.MIN_STEP,min(self.MAX_STEP,self.step))
        
      else: #default
        self.hours=5
        self.step=1
        self.endTime=mktime(localtime())
       
      self.queryTime=self.hours*60*60
      # round at +/- 5 minutes (to enable caching)
      self.endTime=math.floor(self.endTime/300)*300
      self.startTime=self.endTime-self.queryTime
      ############### build siblingsParams for 
      self.siblingParams="tier="+self.tier+"&"
      if self.autotime==False:
         self.siblingParams+="hours=%d&"%(self.hours)
         self.siblingParams+="step=%d&"%(self.step)
         d=datetime.fromtimestamp(self.endTime)
         self.siblingParams+="sh=%d&sd=%d&sm=%d&sy=%d&"%(d.hour,d.day,d.month,d.year)
      else: self.siblingParams+="autotime=1&"
      self.siblingParams+="loadsiblings=0"
      ###########
      line="""<script type="text/javascript">loadXMLDoc('%sId','single?plot=%s&%s');</script>"""
      script=""
      for name in self.layerCont:
         if name!=self.name:
           script+=line%(name+self.suffix,name+self.suffix,self.siblingParams)
      self.loadSiblingsScript=script
    except Exception, e:
       self.message="<BR />Parameter check FAILED <BR/>"+self.message
       print e
       
    
  def getSets(self,inlist,name):
       sets=set()
       sets.update(map(lambda dict :dict[name], inlist))
       return sets
   
  def splitInfoInSets(self,inList,serieClass,serieNameAttr):
        """
        This function create 1 serieClass for every set with the same 'serieNameAttr'.
        It is also possible to add a filtering function.
        """
        step=self.step
        if step<1: step=1
        dataSeries={}
        for line in inList:
            try:
              datasetSerie=dataSeries[line[serieNameAttr]]
            except:
              serie=getattr(SeriesLib,serieClass)
              datasetSerie=serie(line[serieNameAttr],step*60)
              dataSeries.update({line[serieNameAttr]: datasetSerie})
            if self.filterFunction(line):
               datasetSerie.addInfo(line)
            #else: print "filter failed! on line="+str(line)
        return dataSeries
   
  def makePlotOn(self,inList,plotfairyUrl):
      return "Incomplete plot processing..."
   

  def buildLayer(self,serie,legenda,suffix):
    if self.step==0:
       layerPlot={self.layerCont[0]+suffix:eventsPlotNoInt(self.plotfairyUrl,serie,legenda),
                  self.layerCont[1]+suffix:eventSizesPlotNoInt(self.plotfairyUrl,serie,legenda),
                  self.layerCont[2]+suffix:dataRatePlot(self.plotfairyUrl,serie,legenda)}
    else:
       layerPlot={self.layerCont[0]+suffix:eventsPlot(self.plotfairyUrl,serie,legenda),
                       self.layerCont[1]+suffix:eventSizesPlot(self.plotfairyUrl,serie,legenda),
                       self.layerCont[2]+suffix:dataRatePlot(self.plotfairyUrl,serie,legenda)}
    for name,p in layerPlot.iteritems():
         p.makeTitle(self.hours,self.step)
         if name!=self.name:
           try:
             p.saveData(self.getFileName(name))
           except EmptyPlotException:
             pass
    return layerPlot[self.name]
       
  def getFileName(self,name=""):
      if name=="": name=self.name
      options="-"+self.tier+'-'
      if len(str(self.startTime))>0:
       options+="-"+str(self.startTime)+'-'+str(self.endTime)
      if len(str(self.step))>0:
        options+="-"+str(self.step) 
      fileName="jsonData-"+str(name)+options+".json"
      return fileName
      
  def  getOptionsPanel(self):
    form =""
    try:
      dtime=datetime.fromtimestamp(self.endTime)
      hiddens="""<input type="hidden" name="tier" value="%s">"""%(self.tier)+"""<BR/><input type=checkbox name="loadsiblings">Modify all the plots in the row"""
      form =PlotLib.dateForm(self.name,dtime,self.hours,self.hourRange,self.step,self.stepRange,hiddenValues=hiddens)
    except Exception, e:
       print e 
    if self.loadSiblings:
       form+= self.loadSiblingsScript
       
    prefix=self.getSummary()
    if len(prefix)>0: 
      prefix="<B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Plot information:</B> <BR/>"+prefix
    if len(str(self.message))>0:
            self.message="<B>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Parameters log:</B>"+self.message
            
    self.optionLink=self.optionLink%(self.name,self.name,self.name)#,self.name+'Id',self.name+'Id')
    res=self.optionLink+"""<BR/><div id=%s style="display: none;" align="left">"""%(self.name+"Info")
    
    if len(prefix)>0:
        res+=prefix+"<BR/>"
    if len(self.message)>0:
        res+=self.message+"<BR/>"
    if len(form)>0:
       res+=form
    res+="</div>"
    return res  
              
             
 ##########################################################################
class streamEvents(tierPlotContent):
  URL="laststreamssummary?stime=%s&etime=%s&"
  plotName="eventsPlot"
  layerCont=['streamEvents','streamEventsizes','streamDatarate']
  
  def makePlotOn(self,inList,plotfairyUrl):
        streams=self.getSets(inList,'stream')
        legenda=Legend(streams)
        self.plotfairyUrl=plotfairyUrl
        # create series dividing data in 'dataset's
        eventSeries=self.splitInfoInSets(inList,'DatasetSerie','stream')
        retPlot=self.buildLayer(eventSeries,legenda,self.suffix)
        return retPlot
  
  def updateLinks(self):
       if len(self.URL)>0:
         self.URL=self.URL%(str(self.startTime),str(self.endTime))
    
         
class streamEventsizes(streamEvents):
  plotName="eventSizesPlot"

class streamDatarate(streamEvents):
  plotName="dataRatePlot"
  
##################################################################################################################### 
class events(tierPlotContent):
  URL="lastfilessummary?stime=%s&etime=%s&tier=%s"  
  plotName="eventsPlot"

  def makePlotOn(self,inList,plotfairyUrl):
        datasets=self.getSets(inList,'dataset')
        legenda=Legend(datasets)
        self.plotfairyUrl=plotfairyUrl
        # create series dividing data in 'dataset's
        eventSeries=self.splitInfoInSets(inList,'DatasetSerie','dataset')
        # crate and save all the data for the layer!!!
        retPlot=self.buildLayer(eventSeries,legenda,self.suffix)
        #if retPlot==None: print "ERROR!!!!!! "
        return retPlot
  
  def updateLinks(self):
       if len(self.URL)>0:
         self.URL=self.URL%(str(self.startTime),str(self.endTime),str(self.tier))

  
   
class eventsizes(events):
  plotName="eventSizesPlot"
  
class datarate(events):
  plotName="dataRatePlot"
  
##############################3
class eventsOS(events):
  suffix="OS"
  def filterFunction(self,x):
   return  x['stream']=='others' 
  
class eventsizesOS(eventsizes):
  suffix="OS"
  def filterFunction(self,x):
    return x['stream']=='others'

class datarateOS(datarate):
   suffix="OS"
   def filterFunction(self,x):
     return  x['stream']=='others'
##############################3
class eventsAS(events):
  suffix="AS"
  def filterFunction(self,x):
   return  x['stream']=='A' 

class eventsizesAS(eventsizes):
  suffix="AS"
  def filterFunction(self,x):
    return x['stream']=='A' 

class datarateAS(datarate):
   suffix="AS"
   def filterFunction(self,x):
     return  x['stream']=='A'
   ##############################3
class eventsES(events):
  suffix="ES"
  def filterFunction(self,x):
   return  x['stream']=='Express' 

class eventsizesES(eventsizes):
  suffix="ES"
  def filterFunction(self,x):
    return x['stream']=='Express' 

class datarateES(datarate):
   suffix="ES"
   def filterFunction(self,x):
     return   x['stream']=='Express' 