from HTTPfetcher import *
from TableContents import *

import threading


class tableThread(threading.Thread):
    res=""
    def __init__ ( self,DASUrl, content):
     try:
      import Table
      src=Table
      if content.name== 'runDetails':
          import RunDetails
          src=RunDetails
      table=getattr(src,content.tableClass)
      self.table=table(DASUrl,content)
      threading.Thread.__init__ ( self )
     except ConnectionException:
       print "Table Connection Exception"
       raise
     
    def run(self):
       self.res=self.table.getTableCode()
 
    def getHTML(self):
        return self.res
      
      
################################################################
class Table(object):
   """
This class can fetch the data from DAS and format a HTML table based on the received data
   """ 
   RESET_COMBOBOX_SCRIPT="""<script> if (document.getElementById("%sPages")) 
     {document.getElementById("%sPages").selectedIndex =document.getElementById("%sPages").getValue("%d");}</script>"""
   GENERAL_TABLE_RELOAD_LINK=""" <a href=\"javascript:loadXMLDoc('%s','single?table=%s&page=%s','%slinks')\">%s</a> """
   REFRESH_IMAGE=""" <a href="javascript:loadXMLDoc('%s','single?table=%s&page=%s','%slinks')" title="Refresh"> <img src="imgs/reload.png"  alt="" style="border: 0px none;" height="16"></a>"""
   threads=[]
   data=[]
   
   def __init__(self,DASUrl,content):
    try:
      self.DASUrl=DASUrl
      self.content=content
    except:
        print "Table init error!!"
    #fetch information: used only for 1 table
    self.resDict={}
    self.threads=[]
    self.data=[]
    if type(self.content.URL)==StringType and len(self.content.URL)>0:
       t= fetchingThread(DASUrl,self.content.URL,self.resDict)
       self.threads.append(t)
       t.start()
       try:
         if len(self.content.countURL)>0:
          ct=fetchingThread(DASUrl,self.content.countURL,self.resDict)
          self.threads.append(ct)
          ct.start()
       except AttributeError:
        pass
       except ConnectionException:
        raise 
    if type(self.content.URL)==ListType:
         self.threads=[]
         for url in self.content.URL:
           t= fetchingThread(DASUrl,url,self.resDict)
           self.threads.append(t)
           t.start()
      
  
   # some inherited tables may want to know when the data are ready 
   def waitEndFetching(self):
        if self.threads==None:return
        #print "waiting for: "+ self.content.name + "  stat main="+str(self.mainThread.is_alive())
        if type(self.content.URL)==StringType:
          self.threads[0].join()
          self.data=self.resDict[self.content.URL]
          if len(self.threads)>1 and self.data!=None:
            self.threads[1].join()
            self.content.size=self.resDict[self.content.countURL][0][0]
          else:
            self.content.size=None
        if type(self.content.URL)==ListType:
          for t in self.threads:
            t.join()
          for url in self.content.URL:
            self.data+=self.resDict[url]
        #print "waiting finished for: "+ self.content.name
        self.threads=None
       
         
        

   def getData(self):
     self.waitEndFetching()
     return self.data

   
   def getTableCode(self,data={}):
      """
      HTML Code generation for the fetched data [data may be passed as parameter]
      """
      if data=={}:
          self.waitEndFetching()
          data=self.data
      if data==None: 
           return None
      #print "DATA="+str(data)
      # graphs need more information: specific ones for every run   
      for col in self.content.colDecorators:
         if hasattr(col,'auxSuffixes'):
             for line in data:     
                line.update(self.getAuxInfo(col,line))
      ### generate HTML code
      tableTop="""<table border="0" cellspacing="2">
                  <tbody><tr><th colspan=" """+str(len(self.content.colDecorators)) +""""  align="center" > """ +self.content.title+"""</th></tr>"""
      tableTop+="<tr>"
      for c in self.content.colDecorators:
         tableTop+="""<td style="background-color: rgb(185, 208, 222);"> """+c.colName+"</td>"
      tableTop+="</tr>"
      bkground=""   
      tableBody=""
      for line in data:
         tableBody+="<tr>"
         if bkground=="": bkground=""" style="background-color: white;" """
         else: bkground=""
         for col in self.content.colDecorators:
           try: 
            tableBody+="<td"+bkground+">"+col.decorator(line)+"</td>"
           except Exception, e:
              print "Exception: "+str(e) +"  "+str(line)
              tableBody+="<td"+bkground+">"+"No column attribute found"+"</td>"    
         tableBody+="</tr>"
      ## links must be added ONLY if the table is a "long" one
      if self.content.isLongTable:
         tableBody+=self.getLinks(data)
      tableBody+="</tbody></table>"
      
      # reset combo to page value [I need a js because on realod the selection box may contain an old value]
      try:
          if self.pageCombo:
              tableBody+=self.RESET_COMBOBOX_SCRIPT%(self.content.name,self.content.name,self.content.name,self.content.page)
      except:
        pass
      return tableTop+tableBody

    
   def getAuxInfo(self,col,line):
    # No parallelism is needed here. All the coulmn-specific queries are supposed to be really FAST 
    import Columns
    from HTTPfetcher import HTTPfetcher
    runid=line[Columns.RunId().attrNames[0]]
    res={}
    for attr in col.auxSuffixes:
      f=HTTPfetcher(self.DASUrl+attr+col.option%(runid))
      valueDict=f.fetchUrl()
      value = valueDict[0]
      res.update({attr:value})  
    return res
    
    
   def getLinks(self,data):
        ## set up  next/prevous page links for longTables (or comboBox)
        options=""
        try:
            if self.content.run>0:
             options="&run_id="+str(self.content.run)
        except Exception, e:
            options=""
        try:
            if len(self.content.status)>0:
             options+="&status="+str(self.content.status)
        except:
            pass
        
        linksCode="""<tr><td style="background-color: rgb(185, 208, 222);" colspan=" """+str(len(self.content.colDecorators)) +""""  align="center" >"""
        linksCode+="<div id=\""+self.content.name+"links\">"
        contentName=self.content.name
                ### Previous Values Link 
        linksCode+="<table  width=\"100%\"><tr><td style=\"background-color: rgb(185, 208, 222);\">"
        if self.content.page>1:
           linksCode+=self.GENERAL_TABLE_RELOAD_LINK%(contentName,contentName,str(self.content.page-1)+options,contentName,'<img src="imgs/back.png" border="0" width="20">')+"&nbsp;&nbsp;&nbsp; "
        linksCode+="</td><td align=\"center\" style=\"background-color: rgb(185, 208, 222);\">"
        #linksCode+="&nbsp;&nbsp;"
        ## Current Values Link OR page selection box
        currentPage=self.getPageCombo(data,options)
        linksCode+=currentPage+"&nbsp;&nbsp;&nbsp;&nbsp;"+self.REFRESH_IMAGE%(contentName,contentName,str(self.content.page)+options,contentName)
        linksCode+="</td><td align=\"left\"  style=\"background-color: rgb(185, 208, 222);\">"
         ## Next Values Link
        if self.content.page<=(self.content.size// self.content.tableStepSize):
           linksCode+=""+self.GENERAL_TABLE_RELOAD_LINK%(contentName,contentName,str(self.content.page+1)+options,contentName,'<img src="imgs/next.png" border="0" width="20">')
        linksCode+="</td></tr></table>"
        linksCode+="</div></td></tr>"
        return linksCode
        
   def getPageCombo(self,data,options):
        pageCombo=""
        try:
            size=self.content.size
            pageN=size// self.content.tableStepSize
            if size % self.content.tableStepSize >0: pageN=pageN+1
            #print "name="+ self.content.name+"  Size="+str(size)+"  pageN="+str(pageN)
            pageCombo=" Page: <select name=\""+self.content.name+"Pages\" id=\""+self.content.name+"Pages\"  onchange=\"javascript:loadXMLDoc('"+self.content.name+"','single?table="+self.content.name+"&page='+this.options[this.selectedIndex].value+'"+options+"','"+self.content.name+"links','Loading page: '+this.options[this.selectedIndex].value)\" >"""
            for i in range(0,pageN):
                if i+1==self.content.page:
                    selected="selected=\"selected\""
                else: selected=""
                
                try: ## only for runDetail Table which has the 'runs'
                  downLimit=i*self.content.tableStepSize
                  upLimit=min((i+1)*self.content.tableStepSize-1,self.Nruns-1) 
                  pageCombo+=""" <option value="%d" %s>%s</option>"""%(i+1,selected,"%d [%d-%d]"%(i+1,self.runs[downLimit]['run'],self.runs[upLimit]['run']))
                except Exception as e:
                  #print str(e)
                  pageCombo+=""" <option value="%d" %s>%d</option>"""%(i+1,selected,i+1)
            pageCombo+="</select>"
            self.pageCombo=True
        except Exception, e:
          #print e
          pass    
        return pageCombo
        
############################################################################################################
class ConfigMixTable(Table):
   """
   This special table is made to merge 2 different DAS call in 1 table: run-page Reco/Alca Config Table
   """
  
   ## some inherited tables may want to know when the data are ready 
   def waitEndFetching(self):
        if self.threads==None:return
        self.threads[0].join()
        self.firstData=self.resDict[self.content.URL[0]]
        self.threads[1].join()
        self.secondData=self.resDict[self.content.URL[1]]
        self.threads=None
        self.buildData()
        
   def buildData(self):
    self.data=[]
    # in case of data miss, the normal codes rise an exception. If we want to show an empty table just uncomment the following 2 lines
    #if self.firstData==None or len(self.firstData)==0 or self.secondData==None or len(self.secondData)==0:
      #return
    for fLine in self.firstData:
      for sLine in self.secondData:
        if fLine['primary_dataset']==sLine['primary_dataset']:
          newLine={}
          newLine.update(self.keyfilter(fLine,'al_'))
          newLine.update(self.keyfilter(sLine,'ro_'))
          newLine.update({'dataset':sLine['primary_dataset']})
          self.data.append(newLine)
    self.data=sorted(self.data, key=lambda line: line['dataset'])

    
   def keyfilter(self,dict,prefix):
     res={}
     for k,v in dict.iteritems():
       res.update({prefix+k:v})
     return res